--[[
Fusion  http://www.cgsfusion.com
Written by : JUNE  
Written on : May, 2019

2019.6.5 ѡ桢лʱ룬Underlayڵ㡣
2019.6.4 ڵ㡢½Ӵ
2019.5.27 Fusion16׷
]]--
stayontop = false
OpenCLNodeList = {
  'ColorCorrector',
  'GamutConvert',
  'MatteControl',
  'Blur',
}
platform = (FuPLATFORM_WINDOWS and 'Windows') or (FuPLATFORM_MAC and 'Mac') or (FuPLATFORM_LINUX and 'Linux')
function OpenURL(siteName, path)
	if platform == 'Windows' then
		-- Running on Windows
		command = 'explorer "' .. path .. '"'
	elseif platform == 'Mac' then
		-- Running on Mac
		command = 'open "' .. path .. '" &'
	elseif platform == 'Linux' then
		-- Running on Linux
		command = 'xdg-open "' .. path .. '" &'
	else
		print('[Error] There is an invalid Fusion platform detected.')
		return
	end
	
	os.execute(command)
	-- print('[Launch Command] ', command)
	print('[Opening URL] [' .. siteName .. '] ' .. path)
end
local function urlEncode(s)  
	s = string.gsub(s, "([^%w%.%- ])", function(c) return string.format("%%%02X", string.byte(c)) end)  
    return string.gsub(s, " ", "+")  
end  

function _init(side)
    view = get_viewer(side)
    viewer = view.CurrentViewer
    comp = fu:GetCurrentComp()
    if not viewer then
        print('请放入2D节点到 '.. side ..' 视图中')
        return 0
    end
    controls_state = viewer:AreControlsShown()
    locked_state = view:GetLocked()
    quadv_state = view:ShowingQuadView()
    subv_state = view:ShowingSubView()
    lut_state = viewer:IsLUTEnabled()
    roi_state = viewer:IsEnableRoI()
    stereo_state = view:IsStereoEnabled()
    guide_state = viewer:AreGuidesShown()
    --opencl_state = tool:IsGPUEnable()

    if fu.Version >= 16 and not fu:GetAttrs('FUSIONB_IsResolve') then
        dod_state = viewer:IsDoDShown()
        checker_state = viewer:IsCheckerEnabled()
		gg_state = viewer:IsShowGainGamma()
    else
        dod_state = false
        checker_state = false
		gg_state = false
    end
end

function get_viewer(side)
    if side == '左' then
        if fu.Version >= 16 then
            glview = comp:GetPreviewList().LeftView.View
        else
            glview = comp:GetPreviewList().Left.View
        end
    elseif side == '右' then
        if fu.Version >= 16 then
            glview = comp:GetPreviewList().RightView.View
        else
            glview = comp:GetPreviewList().Right.View
        end
    end
    return glview
end

_init('左')
ui = fu.UIManager
disp = bmd.UIDispatcher(ui)

function show_ui()
    width,height = 730,58
    iconsMedium = {16,26}
    iconsMediumLong = {34,26}
    local x = fu:GetMousePos()[1]
    local y = fu:GetMousePos()[2]
    local win = disp:AddWindow({
        ID = 'ToolbarWin',
        TargetID = 'ToolbarWin',
        WindowTitle = 'Fusion Toolbar',
		WindowFlags = {SplashScreen = true,  NoDropShadowWindowHint = true, WindowStaysOnTopHint = stayontop, },
		Events = { Close = true, KeyPress = true, KeyRelease = true, },
        Geometry = {x-(width)/2, y, width, height},
        Spacing = 0,
        Margin = 0,
        
        ui:VGroup{
            ID = 'root',
            ui:HGroup{
                ui:HGroup{
                    Weight = 0.8,
                    ui.HGap(0.25,0),
                    ui:Button{
                        ID = 'IconButtonGuide',
                        Flat = true,
						Icon = ui:Icon{File = 'Scripts:/Comp/CGS/Icons.zip/PT_Guides.png'},
                        MinimumSize = {18,26},
						IconSize = {16,16},
                        Checkable = true,
						Checked = guide_state
                    },
                    ui:Button{
                        ID = 'IconButtonQuadView',
                        Flat = true,
						Icon = ui:Icon{File = 'Scripts:/Comp/CGS/Icons.zip/PT_QuadView.png'},
                        MinimumSize = {18,26},
						--IconSize = {16,16},
                        Checkable = true,
						Checked = quadv_state
                    },
                    ui:Button{
                        ID = 'IconButtonSubView',
                        Text = 'SubV',
                        Flat = true,
                        MinimumSize = {36,10},
                        Checkable = true,
						Checked = subv_state
                    },
                    ui:Button{
                        ID = 'IconButtonZoom',
                        Text = '100%',
                        Flat = true,
                        IconSize = {6,10},
                        MinimumSize = iconsMediumLong,
                        Checkable = false,
                    },
                    ui:Button{
                        ID = 'IconButtonFit',
                        Text = 'Fit',
                        --IconSize = {6,2},
                        Flat = true,
                        MinimumSize = {26,26},
                        Checkable = false,
                    },
                    ui:Button{
                        ID = 'IconButtonPolyline',
                        Flat = true,
                        IconSize = {16,16},
                        Icon = ui:Icon{File = 'Scripts:/Comp/CGS/Icons.zip/PT_Polyline.png'},
                        MinimumSize = iconsMedium,
                        Checkable = false,
                    },
                    ui:Button{
                        ID = 'IconButtonBSpline',
                        Flat = true,
                        IconSize = {16,16},
                        Icon = ui:Icon{File = 'Scripts:/Comp/CGS/Icons.zip/PT_BSpline.png'},
                        MinimumSize = iconsMedium,
                        Checkable = false,
                    },
                    ui:Button{
                        ID = 'IconButtonBitmap',
                        Flat = true,
                        IconSize = {16,16},
                        Icon = ui:Icon{File = 'Scripts:/Comp/CGS/Icons.zip/PT_Bitmap.png'},
                        MinimumSize = iconsMedium,
                        Checkable = false,
                    },
                    ui:Button{
                        ID = 'IconButtonPaint',
                        Flat = true,
                        IconSize = {16,16},
                        Icon = ui:Icon{File = 'Scripts:/Comp/CGS/Icons.zip/PT_Paint.png'},
                        MinimumSize = iconsMedium,
                        Checkable = false,
                    },
                    ui:Button{
                        ID = 'IconButtonWand',
                        Flat = true,
                        IconSize = {16,16},
                        Icon = ui:Icon{File = 'Scripts:/Comp/CGS/Icons.zip/PT_Wand.png'},
                        MinimumSize = iconsMedium,
                        Checkable = false,
                    },
                    ui:Button{
                        ID = 'IconButtonRectangle',
                        Flat = true,
                        IconSize = {16,16},
                        Icon = ui:Icon{File = 'Scripts:/Comp/CGS/Icons.zip/PT_Rectangle.png'},
                        MinimumSize = iconsMedium,
                        Checkable = false,
                    },
                    ui:Button{
                        ID = 'IconButtonCircle',
                        Flat = true,
                        IconSize = {16,16},
                        Icon = ui:Icon{File = 'Scripts:/Comp/CGS/Icons.zip/PT_Circle.png'},
                        MinimumSize = iconsMedium,
                        Checkable = false,
                    },
                    ui:Button{
                        ID = 'IconButtonABuf',
                        Flat = true,
                        Text = '',
                        IconSize = {16,16},
                        Icon = ui:Icon{File = 'Scripts:/Comp/CGS/Icons.zip/PT_ABuffer.png'},
                        MinimumSize = iconsMedium,
						Checkable = true,
						Checked = true,
                    },
                    ui:Button{
                        ID = 'IconButtonSplitBuf',
                        Flat = true,
                        Text = '',
                        IconSize = {16,16},
                        Icon = ui:Icon{File = 'Scripts:/Comp/CGS/Icons.zip/PT_SplitBuffer.png'},
                        MinimumSize = iconsMedium,
						Checkable = true,
                    },
                    ui:Button{
                        ID = 'IconButtonBBuf',
                        Flat = true,
                        Text = '',
                        IconSize = {16,16},
                        Icon = ui:Icon{File = 'Scripts:/Comp/CGS/Icons.zip/PT_BBuffer.png'},
                        MinimumSize = iconsMedium,
                        Checkable = true,
                    },
                    ui:Button{
                        ID = 'IconButtonStereo',
                        Flat = true,
                        Text = '',
                        IconSize = {16,16},
                        Icon = ui:Icon{File = 'Scripts:/Comp/CGS/Icons.zip/PT_Stereo.png'},
                        MinimumSize = iconsMedium,
                        Checkable = true,
                        Checked = stereo_state 
                    },
                    ui:Button{
                        ID = 'IconButtonLUT',
                        Text = 'LUT',
                        Flat = true,
                        IconSize = {5,10},
                        MinimumSize = {26,16},
                        Checkable = true,
                        Checked = lut_state
                    },
                    ui:Button{
                        ID = 'IconButtonROI',
                        Text = 'RoI',
                        Flat = true,
                        IconSize = {5,10},
                        MinimumSize = {24,16},
                        Checkable = true,
                        Checked = roi_state 
                    },
                    ui:Button{
                        ID = 'IconButtonDoD',
                        Text = 'DoD',
                        Flat = true,
                        IconSize = {5,10},
                        --MinimumSize = iconsMediumLong,
                        MinimumSize = {26,16},
                        Checkable = true,
                        Checked = dod_state
                    },
                    ui:Button{
                        ID = 'IconButtonLockCold',
                        Flat = true,
                        Text = '',
                        IconSize = {16,16},
                        Icon = ui:Icon{File = 'Scripts:/Comp/CGS/Icons.zip/PT_LockCold.png'},
                        MinimumSize = iconsMedium,
                        Checkable = true,
                        Checked = locked_state
                    },
                    ui:Button{
                        ID = 'IconButtonControls',
                        Flat = true,
                        Text = '',
                        IconSize = {16,16},
                        Icon = ui:Icon{File = 'Scripts:/Comp/CGS/Icons.zip/PT_Controls.png'},
                        MinimumSize = iconsMedium,
                        Checkable = true,
                        Checked = controls_state
                    },
                    ui:Button{
                        ID = 'IconButtonChequers',
                        Flat = true,
                        Text = '',
                        IconSize = {16,16},
                        Icon = ui:Icon{File = 'Scripts:/Comp/CGS/Icons.zip/PT_Chequers.png'},
                        MinimumSize = iconsMedium,
                        Checkable = true,
                        Checked = checker_state
                    },
                    -- ui:Button{
                    --     ID = 'IconButtonSmR',
                    --     Text = 'SmR',
                    --     Flat = true,
                    --     MinimumSize = iconsMediumLong,
                    --     Checkable = true,
                    -- },
                    -- ui:Button{
                    --     ID = 'IconButtonOne2One',
                    --     Flat = true,
                    --     IconSize = {16,16},
                    --     Icon = ui:Icon{File = 'Scripts:/Comp/CGS/Icons.zip/PT_One2One.png'},
                    --     MinimumSize = iconsMedium,
                    --     Checkable = true,
                    -- },
                    -- ui:Button{
                    --     ID = 'IconButtonNormalise',
                    --     Flat = true,
                    --     IconSize = {16,16},
                    --     Icon = ui:Icon{File = 'Scripts:/Comp/CGS/Icons.zip/PT_Normalise.png'},
                    --     MinimumSize = iconsMedium,
                    --     Checkable = true,
                    -- },
					ui:Button{
                        ID = 'IconButtonSliders',
                        Flat = true,
                        IconSize = {20,20},
						Icon = ui:Icon{File = 'Scripts:/Comp/CGS/Icons.zip/PT_Sliders.png'},					
                        MinimumSize = {20,26},
                        Checkable = true,
                        Checked = gg_state 
                    },
                },
                ui:HGroup{
                    Weight = 0.2,
                    ui:Button{
                        ID = 'Left',
                        Text = 'left',
                        IconSize = {6,2},
                        Flat = true,
                        MinimumSize = iconsMediumLong,
                        Checkable = true,
                        Checked = true,
                    },
                    ui:Button{
                        ID = 'RefreshButtons',
                        Text = '',
                        IconSize = {12,12},
                        -- Flat = true,
                        MinimumSize = iconsMedium,
                        Icon = ui:Icon{File = 'Scripts:/Comp/CGS/Icons.zip/refresh_icon.png'},
                        Enable = false,
                    },                    
                    ui:Button{
                        ID = 'Right',
                        Text = 'right',
                        Flat = true,
                        MinimumSize = iconsMediumLong,
                        IconSize = {6,2},
                        Checkable = true,
                        Checked = false,
                    },                    
					ui:Button{
					  ID = 'CloseButton',
						--Text = 'Close',
						--Flat = false,
						Weight = 0.001,
						Icon = ui:Icon{File = 'Scripts:/Comp/CGS/Icons.zip/PT_Close.png'},
						IconSize = {12,12},
						MinimumSize = {50,26},
						Checkable = false,
					},									
                },
				
            },
			ui:HGroup{
				ui.HGap(0.15,0),
				ui:Button{
					ID = 'NewView',
					--Text = 'ImageView',
					Flat = true,
					Weight = 0.2,
					IconSize = {24,24},
					Icon = ui:Icon{File = 'Scripts:/Comp/CGS/Icons.zip/NewView.png'},
					MinimumSize = {22,26},
					--Checkable = true,
					Checked = false,
				},                    
				ui:Button{
					ID = 'T',
					--Text = 'AddTool',
					Flat = true,
					Weight = 0.2,
					Icon = ui:Icon{File = 'Scripts:/Comp/CGS/Icons.zip/nodes.png'},
					MinimumSize = {24,26},
					IconSize = {24,24},
					--Checkable = true,
					Checked = false,
				},
				ui:Button{
					ID = 'TimecodeShowBTN',
					Text = 'TC',
					Weight = 0.2,
					Flat = true,
					MinimumSize = {24,26},
					IconSize = {6,2},
					Checkable = false,
				},
				ui:Button{
					ID = 'IconBTNUnderlay',
					Text = '',
					Flat = true,
					Weight = 0.2,
					Icon = ui:Icon{File = 'Scripts:/Comp/CGS/Icons.zip/underlay.png'},
					MinimumSize = {24,26},
					IconSize = {24,24},
					Checkable = false,
				},




				ui:Button{
				  ID = 'OpenCLButton',
					Flat = true,
					Text = 'OpenCL',
					Weight = 0.7,
					--Icon = ui:Icon{File = 'Scripts:/Comp/CGS/Icons.zip/MemCache.png'},
					--IconSize = {22,22},
					MinimumSize = {26,26},
					Checkable = true,
					Checked = true,
				},					
				ui:Button{
				  ID = 'PurgeCacheButton',
					Flat = true,
					Weight = 0.2,
					Icon = ui:Icon{File = 'Scripts:/Comp/CGS/Icons.zip/MemCache.png'},
					IconSize = {22,22},
					MinimumSize = {22,26},
					Checkable = false,
				},					
				ui:Button{
				  ID = 'PrefsButton',
					Flat = true,
					Weight = 0.2,
					Icon = ui:Icon{File = 'Scripts:/Comp/CGS/Icons.zip/Prefs.png'},
					IconSize = {18,18},
					MinimumSize = {22,26},
					Checkable = false,
					Checked = false,
				},					
				ui.HGap(1.0,0),
				ui:Label{
					ID = 'SearchLabel',
					Weight = 0.001,
					Text = '站内搜索 :',
					Font = ui:Font{ PixelSize = 12 },
				},
				ui:HGap(0),
				ui:LineEdit{
					Weight = 5.0,
					ID='TextEntryLineEdit',
					Text = '',
					ClearButtonEnabled = true,
				},
				ui:HGap(0),
				ui:Button{
					ID = 'SearchButton',
					Weight = 0.001,
					Text = '\xF0\x9F\x94\x8D',
					Font = ui:Font{ Family = "Symbola", PixelSize = 14 },
					MinimumSize = {50,26},
				},
			},				

        },
    })
    return win
end
win = show_ui()

function win.On.ToolbarWin.Close(ev)
    disp:ExitLoop()
end
function win.On.CloseButton.Clicked(ev)
    disp:ExitLoop()
end
itm = win:GetItems()
function refresh_ui()
    itm.IconButtonStereo.Checked = stereo_state
    itm.IconButtonLUT.Checked = lut_state
    itm.IconButtonROI.Checked = roi_state
    itm.IconButtonDoD.Checked = dod_state
    itm.IconButtonLockCold.Checked = locked_state
    itm.IconButtonSubView.Checked = subv_state
    itm.IconButtonQuadView.Checked = quadv_state
    itm.IconButtonControls.Checked = controls_state 
    itm.IconButtonChequers.Checked = checker_state
    itm.IconButtonGuide.Checked = guide_state
    itm.IconButtonSliders.Checked = gg_state
end

function win.On.Right.Clicked(ev)
    itm.Left.Checked = false
    _init('右')
    refresh_ui()
end
function win.On.Left.Clicked(ev)
    itm.Right.Checked = false
    _init('左')
    refresh_ui()
end
---------- set glview attrs
function win.On.IconButtonGuide.Clicked(ev)
    state = itm.IconButtonGuide.Checked
    viewer = view.CurrentViewer
    if not viewer then
		return
    end		
    viewer:ShowGuides(state)
	viewer:Redraw()
end

function win.On.IconButtonQuadView.Clicked(ev)
    state = itm.IconButtonQuadView.Checked
    view:ShowQuadView(state)
end

function win.On.IconButtonSubView.Clicked(ev)
    state = itm.IconButtonSubView.Checked
    view:ShowSubView(state)
end

function win.On.IconButtonZoom.Clicked(ev)
    state = itm.IconButtonZoom.Checked
    view:SetScale(1)
end

function win.On.IconButtonFit.Clicked(ev)
    state = itm.IconButtonFit.Checked
    view:SetScale(0)
end

function win.On.IconButtonABuf.Clicked(ev)
    state = itm.IconButtonABuf.Checked
	itm.IconButtonSplitBuf.Checked = false
	itm.IconButtonBBuf.Checked = false
    view:SetBuffer(0)
end
function win.On.IconButtonSplitBuf.Clicked(ev)
    state = itm.IconButtonSplitBuf.Checked
	itm.IconButtonABuf.Checked = false
	itm.IconButtonBBuf.Checked = false	
    view:SetBuffer(2)
end
function win.On.IconButtonBBuf.Clicked(ev)
    state = itm.IconButtonBBuf.Checked
	itm.IconButtonABuf.Checked = false
	itm.IconButtonSplitBuf.Checked = false	
    view:SetBuffer(1)
end

function win.On.IconButtonStereo.Clicked(ev)
    state = itm.IconButtonStereo.Checked
    view:EnableStereo()
end

function win.On.IconButtonLockCold.Clicked(ev)
    state = itm.IconButtonLockCold.Checked
    view:SetLocked(state)
end

---------- add tools 
function win.On.IconButtonPolyline.Clicked(ev)
    comp:AddTool('PolylineMask', -32768, -32768)
end

function win.On.IconButtonBSpline.Clicked(ev)
    comp:AddTool('BSplineMask', -32768, -32768)
end

function win.On.IconButtonBitmap.Clicked(ev)
    comp:AddTool('BitmapMask', -32768, -32768)
end

function win.On.IconButtonPaint.Clicked(ev)
    comp:AddTool('PaintMask', -32768, -32768)
end

function win.On.IconButtonWand.Clicked(ev)
    comp:AddTool('WandMask', -32768, -32768)
end

function win.On.IconButtonRectangle.Clicked(ev)
    comp:AddTool('RectangleMask', -32768, -32768)
end

function win.On.IconButtonCircle.Clicked(ev)
    comp:AddTool('EllipseMask', -32768, -32768)
end

------- change view attrs
function win.On.IconButtonLUT.Clicked(ev)
    state = itm.IconButtonLUT.Checked
    viewer = view.CurrentViewer
    if not viewer then
        return
    end
    viewer:EnableLUT(set_lut)
    viewer:Redraw()
end

local shiftdown = false
--local ctrldown = false
function win.On.ToolbarWin.KeyPress(ev)
	if ev.Key == 0x1000020 then
	shiftdown = true
	--itm.NewView.Text = "FloatFrame"
	itm.NewView.Icon = ui:Icon{File = "Scripts:/Comp/CGS/Icons.zip/NewFrame.png"}
	end
end 
function win.On.ToolbarWin.KeyRelease(ev)
	if ev.Key == 0x1000020 then
	shiftdown = false
	--itm.NewView.Text = "ImageView"
	itm.NewView.Icon = ui:Icon{File = "Scripts:/Comp/CGS/Icons.zip/NewView.png"}
	end
end

--[[
function win.On.ToolbarWin.KeyPress(ev)
	if ev.Key == 0x1700020 then
	ctrldown = true
	itm.T.Text = "AddAction"
	end
end 
function win.On.ToolbarWin.KeyRelease(ev)
	if ev.Key == 0x1700040 then
	ctrldown = false
	itm.T.Text = "AddTool"
	end
end
]]--

function win.On.IconButtonROI.Clicked(ev)
    state = itm.IconButtonROI.Checked
    viewer = view.CurrentViewer
    if not viewer then
        return
    end
    viewer:EnableRoI(state)
    viewer:Redraw()
--	if shiftdown then
--		view:ResetRoI()
--		view:Redraw()
--		print("Set")
--	else
--		viewer:EnableRoI(state)
--		viewer:Redraw()
--	end	
end

function win.On.IconButtonDoD.Clicked(ev)
    state = itm.IconButtonDoD.Checked
    viewer = view.CurrentViewer
    if not viewer then
        return
    end
    viewer:ShowDoD()
    viewer:Redraw()
end

function win.On.IconButtonControls.Clicked(ev)
    state = itm.IconButtonControls.Checked
    viewer = view.CurrentViewer
    if not viewer then
        return
    end
    viewer:ShowControls(state)
    viewer:Redraw()
end

function win.On.IconButtonChequers.Clicked(ev)
    state = itm.IconButtonChequers.Checked
    if fu.Version >= 16 then
        viewer = view.CurrentViewer
        if not viewer then
            return
        end
        viewer:EnableChecker(state)
        viewer:Redraw()
    else
        print('暂不支持Fusion9，请使用自带的工具栏。')	
    end
end

function win.On.IconButtonSliders.Clicked(ev)
    state = itm.IconButtonSliders.Checked
    if fu.Version >= 16 then
		viewer = view.CurrentViewer
		if not viewer then
			return
		end
		viewer:ShowGainGamma(state)
	else
        print('暂不支持Fusion9，请使用自带的工具栏。')	
    end	
end

function win.On.RefreshButtons.Clicked(ev)
    if itm.Left.Checked == true then
       side = '左'
    else
       side = '右'
    end
    _init(side)
    _init(side)
    refresh_ui()
end

function win.On.SearchButton.Clicked(ev)
	--print('[Search]')
	DoSearch()
	disp:ExitLoop()
end

function DoSearch()
	q = itm.TextEntryLineEdit.Text
	searchURL = "http://zhannei.baidu.com/cse/search?s=5350096744169428723&q=" .. urlEncode(q)
	OpenURL("Fusion中文网", searchURL)
end

function win.On.NewView.Clicked(ev)
	--app:NewImageView()
	if shiftdown then		
		app:NewFloatFrame()		
	else
		app:NewImageView()
	end	
	--app:NewTabbedFrame()
end

function win.On.T.Clicked(ev)
	q = itm.TextEntryLineEdit.Text
	comp:ChooseTool()
	--if ctrldown then		
	--	comp:ChooseAction()		
	--else
	--	comp:ChooseTool()
	--end	
	--comp:AddTool(q,-32768,-32768)
	--comp:AddToolAction(q,-32768,-32768)
	--comp:AddSettingAction(urlEncode(q),-32768,-32768)
	--comp:DoAction("AddSetting", { filename = 'Fuses:/CGS_OpticalFlares.zip/Cool.setting' })
end

function win.On.TimecodeShowBTN.Clicked(ev)
	state = itm.TimecodeShowBTN.Checked
	if state == false then
		state = (comp:GetPrefs('Comp.FrameFormat.TimeCodeType') == app.TC_PRF_Frame)
	end
	if state then
		comp:SetPrefs('Comp.FrameFormat.TimeCodeType', comp:GetPrefs('Comp.FrameFormat.TimeCodeRadio'))
	else
		comp:SetPrefs('Comp.FrameFormat.TimeCodeType', app.TC_PRF_Frame)
	end

--	if state == false then
--		comp:SetPrefs('Comp.FrameFormat.TimeCodeType', comp:GetPrefs('Comp.FrameFormat.TimeCodeRadio'))
--	else
--		comp:SetPrefs('Comp.FrameFormat.TimeCodeType', app.TC_PRF_Frame)
--	end	
end
function win.On.IconBTNUnderlay.Clicked(ev)
    comp:AddTool('Underlay', -32768, -32768)
end

function win.On.OpenCLButton.Clicked(ev)
	state = itm.OpenCLButton.Checked
	--compList = fu:GetCompList()	
	--for i = 1, table.getn(compList) do
		--cmp = compList[i]
		-- Scan the active comp file for OpenCL nodes
		--for _,id in ipairs(OpenCLNodeList) do
			local node = 0
			--for _,t in pairs(cmp:GetToolList(false, id)) do
			for _,t in ipairs(comp:GetToolList(true)) do
				if fu.Version >= 16 then
					if state == false then
						t.UseGPU[0] = 0
						node = node + 1
					else
						t.UseGPU[0] = 1
						node = node + 1
					end
				else
					if state == false then
						t.UseOpenCL[0] = 0
						node = node + 1
					else
						t.UseOpenCL[0] = 1
						node = node + 1
					end				
				end		
			end
		--end
	--end
end


function win.On.PurgeCacheButton.Clicked(ev)
	fusion.CacheManager:Purge()
end
function win.On.PrefsButton.Clicked(ev)
	app:ShowPrefs('PrefsFlow')
end




-- The app:AddConfig() command will capture the "Escape" hotkey to close the window.
app:AddConfig('ToolbarWin', {
    Target {
        ID = 'ToolbarWin',
    },

    Hotkeys {
        Target = 'ToolbarWin',
        Defaults = true,
        ESCAPE = 'Execute{cmd = [[app.UIManager:QueueEvent(obj, "Close", {})]]}',
        TAB = 'Execute{cmd = [[app.UIManager:QueueEvent(obj, "Close", {})]]}',
    },
})

-- Display the window
win:Show()
--win:显示()


-- Keep the window updating until the script is quit
disp:RunLoop()
win:Hide()
--win:隐藏()
app:RemoveConfig('ToolbarWin')
collectgarbage()
print('欢迎使用，若喜欢可以赞助我们。http://azz.net/cgsfusion')

